$!+
$! create an INITTAB for CONFIG.C
$!-
$!
$!
$ _D = 0
$ close/nolog FIL_INP
$ close/nolog FIL_OPT
$ close/nolog FIL_OUT
$ close/nolog FIL_TMP
$!
$ if (P1 .eqs. "HELP")
$ then
$   goto SHOW_HELP
$ endif
$ if (P1 .eqs. "")
$ then
$   write SYS$ERROR "%CONFIG_INITTAB2MAR-I-P1DEF, parameter 1 defaulted"
$   P1 = "PYTHON_VMS:CONFIG.DAT"
$   write SYS$ERROR " \''P1'\"
$ endif
$ T_NAM = F$PARSE(P1,,,"NAME")
$ T_FIL_INP = T_NAM+ ".DAT"
$ T_FIL_OUT = "CONFIG_INITTAB.MAR"	! T_NAM+ ".MAR"
$! ----------
$ if (F$TRNLNM("PYTHON_CFG_ENVIRONMENT") .eqs. "DCL")
$ then
$   _CFG_ENV_NAM = "D"
$ else
$   _CFG_ENV_NAM = "P"	! assume POSIX
$ endif ! (F$TRNLNM("PYTHON_CFG_ENVIRONMENT"))
$! ----------------------------------------
$ if (F$LOCATE("D",P2) .eq. F$LENGTH(P2))
$ then
$   if (F$TRNLNM("PYTHON_CFG_ENVIRONMENT") .eqs. "DCL")
$   then
$     write SYS$ERROR "%CONFIG_INITTAB2MAR-I-DCLCFG, configuring for DCL environment"
$     P2 = P2 + "D"
$   endif
$ endif
$! ----------------------------------------
$ if (F$LOCATE("P",P2) .eq. F$LENGTH(P2))
$ then
$   if (F$TRNLNM("PYTHON_CFG_ENVIRONMENT") .eqs. "POSIX")
$   then
$     write SYS$ERROR "%CONFIG_INITTAB2MAR-I-PSXCFG, configuring for POSIX environment"
$     P2 = P2 + "P"
$   endif
$ endif
$! ----------------------------------------
$ if (F$LOCATE("T",P2) .eq. F$LENGTH(P2))
$ then
$   if (F$TRNLNM("PYTHON_CFG_THREADS"))
$   then
$     write SYS$ERROR "%CONFIG_INITTAB2MAR-I-THRCFG, configuring for THREADS"
$     P2 = P2 + "T"
$   endif
$ endif
$! ----------------------------------------
$ _ALQ_INP = F$FILE_ATTRIBUTES(T_FIL_INP,"ALQ")	! pre-allocate .MAR file
$ _ALQ_OUT = _ALQ_INP
$ _ALQ_TMPTXT = _ALQ_INP * 2 / 3
$!
$ T_TITLE  = ""
$ TAB[0,8] = 9
$!
$ open/read  FIL_INP 'T_FIL_INP' ! 'P1'
$ open/write FIL_OPT CONFIG.OPT
$!-- open/write FIL_OUT 'T_FIL_OUT'	!
$ copy /nolog _NLA0: /ALLOCATION='_ALQ_OUT' 'T_FIL_OUT'
$ open/append FIL_OUT 'T_FIL_OUT'
$ T_NOW = F$TIME()
$ T_DATE = F$CVTIME(T_NOW,"COMPARISON","YEAR")  + -
	   F$CVTIME(T_NOW,"COMPARISON","MONTH") + -
	   F$CVTIME(T_NOW,"COMPARISON","DAY")   !!!
$ write FIL_OUT "; NOW=", T_NOW , -
		" USR=",F$EDIT(F$GETJPI(0,"USERNAME"),"COLLAPSE")
$ write FIL_OUT ";"
$ write FIL_OUT TAB,".title CONFIG_INITTAB table"
$ write FIL_OUT TAB,".ident '", T_DATE, "'"
$ write FIL_OUT ";"
$ write FIL_OUT "_PyImport_Inittab::"
$!
$ write FIL_OPT "! NOW=", T_NOW , -
		" USR=",F$EDIT(F$GETJPI(0,"USERNAME"),"COLLAPSE")
$ write FIL_OPT "!"
$ write FIL_OPT "!",TAB,"from CONFIG.DAT"
$ write FIL_OPT "!",TAB,".ident '", T_DATE, "'"
$ write FIL_OPT "!"
$!
$ L_ADDRESS_COUNT = 1
$!
$ T_ASCIZ_TMP = "SYS$SCRATCH:CONFIG_INITTAB2MAR_ASCIZ_''F$GETJPI(0,"PID")'.TMP"
$!-- open/write FIL_TMP 'T_ASCIZ_TMP'
$ copy /nolog _NLA0: /ALLOCATION='_ALQ_TMPTXT' 'T_ASCIZ_TMP'
$ open/append FIL_TMP 'T_ASCIZ_TMP'
$!
$ _F = F$SEARCH("@")	! delete old context
$LOOP_VMSDEF:
$ read /END_OF_FILE=VMSDEF_EOF FIL_INP T_RECORD
$ if _D then $ show symbol T_RECORD
$ if (F$EXTRACT(0,1,T_RECORD) .eqs. "!")
$ then
$   goto LOOP_VMSDEF				! skip comment lines
$ endif
$ if (F$EXTRACT(0,1,T_RECORD) .eqs. ";")
$ then
$   write FIL_OUT T_RECORD		! -- copy comment into output file
$   goto LOOP_VMSDEF
$ endif
$ if (F$EDIT(T_RECORD,"COLLAPSE") .eqs. "")
$ then
$   goto LOOP_VMSDEF				! skip empty line
$ endif
$! -----
$ T_RECORD = F$EDIT(T_RECORD,"COMPRESS")	! only single <SP> as delimiter
$ T_MODULE = F$ELEMENT(0," ",T_RECORD)
$ T_SYMBOL = F$ELEMENT(1," ",T_RECORD)
$ T_CFG    = F$ELEMENT(2," ",T_RECORD)
$ T_CFG    = F$EDIT(T_CFG,"UNCOMMENT")	! strip trailing comments
$ T_OPT    = F$ELEMENT(3," ",T_RECORD)
$ T_OPT    = F$EDIT(T_OPT,"UNCOMMENT")	! strip trailing comments
$! -----
$ if (T_MODULE .eqs. "0")
$ then
$   ! end of list
$   write FIL_OUT TAB,";"
$   write FIL_OUT TAB,".long", TAB, "0, 0"
$ else	! continue translation, even if list of table reached
$   !   !  this allows to translate entries beyond the end mark
$   X_CFG = 0
$   ! check configuration
$   CFG_IDX = 0
$   CHK_CFG:
$     if (CFG_IDX .ge. F$LENGTH(P2))
$     then
$       goto CHK_DONE
$     endif
$     T_CHK = F$EXTRACT(CFG_IDX,1,P2)
$     if (F$LOCATE(T_CFG,T_CHK) .ne. F$LENGTH(T_CFG))
$     then
$       X_CFG = 1			! config matches
$     endif
$     CFG_IDX = CFG_IDX + 1
$   goto CHK_CFG			! loop
$   !
$   CHK_DONE:
$   if (.not. X_CFG) then $ goto LOOP_VMSDEF
$   write FIL_TMP "CONFIG_T_INITTAB__''L_ADDRESS_COUNT':''TAB'.asciz '",T_MODULE ,"'"
$   write FIL_OUT TAB,".address CONFIG_T_INITTAB__''L_ADDRESS_COUNT'" ! char*name
$   if (T_SYMBOL .eqs. "NULL")
$   then
$     write FIL_OUT TAB,".long", TAB, "0"	! void (*initfunc)();
$   else
$     write FIL_OUT TAB,".address ", T_SYMBOL	! void (*initfunc)();
$   endif
$   L_ADDRESS_COUNT = L_ADDRESS_COUNT + 1
$   !
$   if ((T_OPT .nes. "") .and. (T_OPT .nes. " "))
$   then
$	write FIL_OPT T_OPT
$   endif
$   !
$ endif
$ goto LOOP_VMSDEF		! next file
$!
$VMSDEF_EOF:
$!+
$! terminate list
$!-
$ write FIL_OUT TAB,";"
$ write FIL_OUT TAB,".long", TAB, "0, 0"
$ write FIL_OUT ";"
$!
$ close/nolog FIL_INP
$ close/nolog FIL_OPT
$ close/nolog FIL_OUT
$ write FIL_TMP TAB,"; no termination necessary"
$ close/nolog FIL_TMP
$!
$ append 'T_ASCIZ_TMP' 'T_FIL_OUT'
$ delete 'T_ASCIZ_TMP';*
$!
$ open/append FIL_OUT 'T_FIL_OUT'
$ write FIL_OUT ";"
$ write FIL_OUT TAB,".end"
$ close/nolog FIL_OUT
$!
$ exit
$! ----------------------------------------------------------------------------
$SHOW_HELP:
$ WRO = "write SYS$OUTPUT"
$ WRO ""
$ WRO " CONFIG_INITTAB2MAR HELP"
$ WRO ""
$ WRO " Parameter 1: name of input file (e.g. CONFIG.DAT)"
$ WRO ""
$ WRO " Parameter 2: configuration information"
$ WRO "    D = DCL environment"
$ WRO "    P = POSIX environment"
$ WRO ""
$ exit 1
