$!++
$! link PYTHON program -- Uwe Zessin
$!--
$ write SYS$OUTPUT F$FAO("!79*-")
$ _DEFAULT = F$ENVIRONMENT("DEFAULT")
$ on ERROR then $ goto PROC_EXIT
$! ----------------------------------------------------------------------------
$ if F$TRNLNM("PYTHON_CFG_DEBUG") .eqs. ""
$ then
$   write SYS$ERROR "%LINK_PY-W-NOSETUP, SETUP.COM not run - doing now"
$   @ PYTHON_VMS:SETUP
$ endif
$! -----
$ _CFG_TXT = ""
$! ----------------------------------------
$ if (F$TRNLNM("PYTHON_CFG_CXX"))
$ then
$   _CFG_TXT     = _CFG_TXT + "CXX,"
$   _CFG_LNKCMD  = "CXXLINK/LOG"
$ else
$   _CFG_TXT     = _CFG_TXT + "CC,"
$   _CFG_LNKCMD  = "LINK"
$ endif
$! ----------------------------------------
$ if (F$TRNLNM("PYTHON_CFG_DEBUG"))
$ then
$   _CFG_DEBUG   = 1
$   _CFG_TXT     = _CFG_TXT + "DEBUG,"
$   _CFG_DBG_NAM = "D"
$   _CFG_DBG_DLM = "_"	! delimiter between OLB filename and "D"
$ else
$   _CFG_DEBUG   = 0
$   _CFG_TXT     = _CFG_TXT + "noDEBUG,"
$   _CFG_DBG_NAM = "0"
$   _CFG_DBG_DLM = ""
$ endif
$! ----------------------------------------
$ _CFG_LNK_QUAL = ""
$ if (F$TRNLNM("PYTHON_CFG_ENVIRONMENT") .eqs. "DCL")
$   then
$   _CFG_ENV_NAM = "D"
$   _OBJTYP      = ".OBJ"
$   _OLBTYP      = ".OLB"
$   _PSXSHR      = ""
$   _CFG_TXT     = _CFG_TXT + "ENV=DCL,"
$ else
$   _CFG_ENV_NAM = "P"	! assume POSIX
$   _OBJTYP      = ".O"
$   _OLBTYP      = ".A"
$   _CFG_TXT     = _CFG_TXT + "ENV=POSIX,"
$   _PSXSHR      = ",SYS$LIBRARY:POSIXC$SHR_OPTION/OPTIONS"
$ endif ! (F$TRNLNM("PYTHON_CFG_ENVIRONMENT"))
$! ----------------------------------------
$ if (F$TRNLNM("PYTHON_CFG_THREADS"))
$ then
$   _CFG_THREADS = 1
$   _CFG_TXT     = _CFG_TXT + "THREADS"
$   _CFG_THR_NAM = "T"
$   if (F$GETSYI("VERSION") .ges. "V7")
$   then
$     _CFG_LNK_QUAL = "/THREADS_ENABLE=(MULTIPLE_KERNEL_THREADS,UPCALLS)"
$   else
$     _CFG_LNK_QUAL = ""
$   endif
$ else
$   _CFG_THREADS  = 0
$   _CFG_TXT      = _CFG_TXT + "noTHREADS"
$   _CFG_THR_NAM  = "0"
$   _CFG_LNK_QUAL = ""
$ endif
$! ----------------------------------------
$ if (_CFG_TXT .nes. "")
$ then
$   write SYS$ERROR "%LINK_PY-I-CFGINFO, configured for: ", _CFG_TXT
$ endif
$! ----------------------------------------------------------------------------
$ _OLB_SUF = "_" + _CFG_ENV_NAM + _CFG_DBG_NAM + _CFG_THR_NAM
$!
$! ----------------------------------------------------------------------------
$ _PROCEDURE = F$ENVIRONMENT("PROCEDURE")
$ _DEVICE    = F$PARSE(_PROCEDURE,,,"DEVICE")
$ _DIRECTORY = F$PARSE(_PROCEDURE,,,"DIRECTORY")
$ set DEFAULT PYTHON_VMS:
$!
$! ----------------------------------------------------------------------------
$ if (F$GETSYI("CPU") .gt. 127)
$ then
$   _ARCH = "ALPHA"
$   SYSEXE_LINK = "/sysexe"
$ else
$   _ARCH = "VAX"
$   SYSEXE_LINK = ",SYS$SYSTEM:SYS.STB/selective"
$ endif		!  ^-- command line parsing, no comma on Alpha
$!
$! ----------------------------------------------------------------------------
$ if (_CFG_ENV_NAM .eqs. "D")
$ then
$   _EXETYP = "EXE"
$ else
$   _EXETYP = ""
$ endif
$!
$ write SYS$ERROR "%LINK_PY-I-LINKPRG, linking program PYTHON_''_ARCH'.''_EXETYP'"
$!
$ '_CFG_LNKCMD'  'P1'  '_CFG_LNK_QUAL' -
	- ! /cross -
  /executable=	PYTHON_VMS:PYTHON_'_ARCH'.'_EXETYP' -
  /map=		PYTHON_VMS:PYTHON_'_CFG_ENV_NAM'_'_ARCH'.MAP -
   PYTHON_OLB:MODULES'_OLB_SUF''_OLBTYP'   /library/INCLUDE=(PYTHON) - ! main()
  ,PYTHON_OLB:VMS_MACRO'_OLB_SUF''_OLBTYP' /library /INCLUDE=(CONFIG_INITTAB) - ! since V1.5.2-V004 (was CONFIG.OBJ)
  ,PYTHON_OLB:PYTHON'_OLB_SUF''_OLBTYP'    /library -
  ,PYTHON_OLB:MODULES'_OLB_SUF''_OLBTYP'   /library -
  ,PYTHON_OLB:OBJECTS'_OLB_SUF''_OLBTYP'   /library -
  ,PYTHON_OLB:PARSER'_OLB_SUF''_OLBTYP'    /library -
  ,PYTHON_OLB:VMS'_OLB_SUF''_OLBTYP'       /library -
  ,PYTHON_OLB:VMS_MACRO'_OLB_SUF''_OLBTYP' /library -
  ,PYTHON_OLB:VMS'_OLB_SUF''_OLBTYP'       /library - ! again
  ,PYTHON_OLB:PYTHON'_OLB_SUF''_OLBTYP'    /library - ! agn for strdup() lookup
  ,PYTHON_VMS:CONFIG.OPT /options - ! created by CONFIG_INITTAB2MAR.COM
 'SYSEXE_LINK' -             ! <---^ comma optionally in symbol
 '_PSXSHR' -
  ,PYTHON_VMS:PYTHON.OPT /options
$!
$!
$ set FILE /VERSION_LIMIT=2  /PROTECTION=(G:RE,W:RE) -
	   PYTHON_VMS:PYTHON_'_ARCH'.'_EXETYP', -
	   PYTHON_VMS:PYTHON_'_CFG_ENV_NAM'_'_ARCH'.MAP
$!
$! ----------------------------------------------------------------------------
$!
$PROC_EXIT:
$ set DEFAULT '_DEFAULT'
