/* VMS_SMG.C -- 28-FEB-2000 Uwe Zessin (ZE.)
   interface to (some) OpenVMS SMG$ routines
*/

#include "python.h"

/* ------------------------------------------------------------------------- */

PyObject *vms_smg_gr_error;		/* exception vms_smg.error */

static char vms_smg_doc__ [] =
"This is an interface to some OpenVMS SMG$ routines.\n\
See the VMS_SMG documentation for details.";

static char vms_smg_t_cant_init   [] = "can't initialize module vms_smg";
static char vms_smg_t_cant_deferr [] = "can't define vms_smg.error";

/* ------------------------------------------------------------------------- */

/* static struct PyMethodDef vms_smg_methods[] = {
--	{NULL,		NULL}
-- }; */

/* data is in file 'VMS_SMG__METHODS.DAT' */
/* see 'General Manual', configuration guidelines */
extern struct PyMethodDef vms_smg__methods[];

/* ------------------------------------------------------------------------- */

void
initvms_smg()
{
	PyObject *m, *d;

	m = Py_InitModule4("vms_smg",
			   vms_smg__methods,
			   vms_smg_doc__,
			   (PyObject *)NULL,
			   PYTHON_API_VERSION);
	d = PyModule_GetDict(m);

	/* -------------------- */
        if (PyErr_Occurred())
	{
	    (void) Py_FatalError(vms_smg_t_cant_init);
	}

	/* -------------------- */
	/* Initialize exception */
	vms_smg_gr_error = PyErr_NewException("vms_smg.error", NULL, NULL);
	if (vms_smg_gr_error == NULL)
	{
	    (void) Py_FatalError(vms_smg_t_cant_deferr);
	}

	if (PyDict_SetItemString(d, "error", vms_smg_gr_error) != 0)
	{
	    (void) Py_FatalError(vms_smg_t_cant_deferr);
	}
} /* initvms_smg () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG.C */
