/* VMS_SMG_COPY_VIRTUAL_DISPLAY.C -- 05-MAR-2000 Uwe Zessin
   Python interface to SMG$COPY_VIRTUAL_DISPLAY

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_COPY_VIRTUAL_DISPLAY

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_COPY_VIRTUAL_DISPLAY "20000305"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <smg$routines.h>	/* SMG$name  */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_copy_virtual_dpy__doc[] =
"new_display_id = vms_smg.copy_virtual_display (current_display_id)\n\
Copy a Virtual Display.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_copy_virtual_display (PyObject *self, PyObject *args)
{
	unsigned long		  l_current_display_id;

	unsigned long		  l_new_display_id;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i"
	    ,&l_current_display_id
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: current_display_id */

	/* -------------------- */
	l_status = smg$copy_virtual_display
		(&l_current_display_id
		,&l_new_display_id
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    return Py_BuildValue ("i", l_new_display_id);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_copy_virtual_display () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_COPY_VIRTUAL_DISPLAY.C */
