/* VMS_SMG_DELETE_KEY_DEF.C -- 06-MAR-2000 Uwe Zessin
   Python interface to SMG$DELETE_KEY_DEF

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_DELETE_KEY_DEF

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_DELETE_KEY_DEF "20000306"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <descrip.h>
#include <smg$routines.h>	/* SMG$name  */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_delete_key_def__doc[] =
"None = vms_smg.delete_key_def (key_table_id, key_name, [if_state])\n\
Delete Key Definition.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_delete_key_def (PyObject *self, PyObject *args)
{
	unsigned long		  l_key_table_id;

	char			* at_key_name;
	struct dsc$descriptor_s   r_key_name;
	unsigned long		  l_key_name_len;

	char			* at_if_state;
	struct dsc$descriptor_s   r_if_state;
	struct dsc$descriptor_s * ar_if_state;
	unsigned long		  l_if_state_len;

	unsigned long		  l_status;

	/* -------------------- */
	at_if_state = 0; l_if_state_len = 0;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "ls#|z#"
	    ,&l_key_table_id
	    ,&at_key_name, &l_key_name_len
	    ,&at_if_state, &l_if_state_len
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: key_table_id */

	/* -------------------- */
	/* argument 2: key_name */
	if (l_key_name_len > 65535)
	{
	    PyErr_SetString(PyExc_ValueError,
	     "argument 2: key_name - string size limited to 65535 characters");
	    return NULL;
	}
	r_key_name.dsc$w_length  = l_key_name_len;
	r_key_name.dsc$b_dtype   = DSC$K_DTYPE_T;
	r_key_name.dsc$b_class   = DSC$K_CLASS_S;
	r_key_name.dsc$a_pointer = at_key_name;

	/* -------------------- */
	/* argument 3: [if_state] */
	if (at_if_state == NULL)
	{
	    ar_if_state = 0;	/* omitted */
	}
	else
	{
	    if (l_if_state_len > 65535)
	    {
		PyErr_SetString(PyExc_ValueError,
	     "argument 3: if_state - string size limited to 65535 characters");
		return NULL;
	    }
	    r_if_state.dsc$w_length  = l_if_state_len;
	    r_if_state.dsc$b_dtype   = DSC$K_DTYPE_T;
	    r_if_state.dsc$b_class   = DSC$K_CLASS_S;
	    r_if_state.dsc$a_pointer = at_if_state;
	    ar_if_state = &r_if_state;
	}

	/* -------------------- */
	l_status = smg$delete_key_def
		(&l_key_table_id
		,&r_key_name
		,ar_if_state
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_delete_key_def () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_DELETE_KEY_DEF.C */
