/* VMS_SMG_DELETE_LINE.C -- 06-MAR-2000 Uwe Zessin
   Python interface to SMG$DELETE_LINE

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_DELETE_LINE

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_DELETE_LINE "20000306"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <smg$routines.h>	/* SMG$name  */
#include <smgmsg.h>		/* SMG$_name */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_delete_line__doc[] =
"status = vms_smg.delete_line (display_id, start_row, [number_of_rows])\n\
Delete Line.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_delete_line (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;

	long			  l_start_row;

	PyObject		* ar_number_of_rows;
	long			  l_number_of_rows;
	long			* al_number_of_rows;

	unsigned long		  l_status;

	/* -------------------- */
	ar_number_of_rows = Py_None;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "ii|O"
	    ,&l_display_id
	    ,&l_start_row
	    ,&ar_number_of_rows
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	/* argument 2: [start_row] */

	/* -------------------- */
	/* argument 3: [number_of_rows] */
	if (ar_number_of_rows == Py_None)
	{
	    al_number_of_rows = 0;		/* omitted */
	    l_number_of_rows  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_number_of_rows))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 3: number_of_rows - must be integer or None");
		return NULL;
	    }
	    l_number_of_rows = PyInt_AsLong(ar_number_of_rows);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_number_of_rows = &l_number_of_rows;
	}

	/* -------------------- */
	l_status = smg$delete_line
		(&l_display_id
		,&l_start_row
		,al_number_of_rows
		);

	/* -------------------- */
	if ((l_status == SS$_NORMAL) || (l_status == SMG$_WILUSERMS))
	{
	    return Py_BuildValue ("i", l_status);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_delete_line () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_DELETE_LINE.C */
