/* VMS_SMG_DELETE_VIEWPORT.C -- 06-MAR-2000 Uwe Zessin
   Python interface to SMG$DELETE_VIEWPORT

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_DELETE_VIEWPORT

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_DELETE_VIEWPORT "20000306"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <smg$routines.h>	/* SMG$name */
#include <ssdef.h>		/* SS$_name */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_delete_viewport__doc[] =
"None = vms_smg.delete_viewport (display_id)\n\
Delete a Viewport.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_delete_viewport (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i", &l_display_id))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	l_status = smg$delete_viewport (&l_display_id);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_delete_viewport () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_DELETE_VIEWPORT.C */
