/* VMS_SMG_DELETE_VIRTUAL_DISPLAY.C -- 04-MAR-2000 Uwe Zessin
   Python interface to SMG$DELETE_VIRTUAL_DISPLAY

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_DELETE_VIRTUAL_DISPLAY

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_DELETE_VIRTUAL_DISPLAY "20000304"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <smg$routines.h>	/* SMG$name  */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_delete_virtual_dpy__doc[] =
"None = vms_smg.delete_virtual_display (display_id)\n\
Delete Virtual Display.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_delete_virtual_display (PyObject *self, PyObject *args)
{
	unsigned long	l_display_id;
	unsigned long	l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "l"
	    ,&l_display_id
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	l_status = smg$delete_virtual_display (&l_display_id);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_delete_virtual_display () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_DELETE_VIRTUAL_DISPLAY.C */
