/* VMS_SMG_FLUSH_BUFFER.C -- 09-MAR-2000 Uwe Zessin
   Python interface to SMG$FLUSH_BUFFER

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_FLUSH_BUFFER

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_FLUSH_BUFFER "20000309"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <smg$routines.h>	/* SMG$name  */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_flush_buffer__doc[] =
"None = vms_smg.flush_buffer (pasteboard_id)\n\
Flush Buffer.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_flush_buffer (PyObject *self, PyObject *args)
{
	unsigned long		  l_pasteboard_id;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i", &l_pasteboard_id))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: pasteboard_id */

	/* -------------------- */
	l_status = smg$flush_buffer (&l_pasteboard_id);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_flush_buffer () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_FLUSH_BUFFER.C */
