/* VMS_SMG_GET_PASTING_INFO.C -- 21-MAR-2000 Uwe Zessin
   Python interface to SMG$GET_PASTING_INFO

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_GET_PASTING_INFO

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_GET_PASTING_INFO "20000321"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name  */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_get_pasting_info__doc[] =
"flags, pasteboard_row, pasteboard_column\
 = vms_smg.get_pasting_info (display_id, pasteboard_id)\n\
Return Pasting Information.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_get_pasting_info (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;
	unsigned long		  l_pasteboard_id;

	unsigned long		  l_flags;
	long			  l_pasteboard_row;
	long			  l_pasteboard_column;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "ii"
	    ,&l_display_id
	    ,&l_pasteboard_id
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	/* argument 2: pasteboard_id */

	/* -------------------- */
	l_status = smg$get_pasting_info
		(&l_display_id
		,&l_pasteboard_id
		,&l_flags
		,&l_pasteboard_row
		,&l_pasteboard_column
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    return Py_BuildValue ("iii"
		,l_flags
		,l_pasteboard_row
		,l_pasteboard_column
		);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_get_pasting_info () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_GET_PASTING_INFO.C */
