/* VMS_SMG_HOME_CURSOR.C -- 21-MAR-2000 Uwe Zessin
   Python interface to SMG$HOME_CURSOR

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_HOME_CURSOR

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_HOME_CURSOR "20000321"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name */
#include <ssdef.h>		/* SS$_name */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_home_cursor__doc[] =
"None = vms_smg.home_cursor (display_id, position_code)\n\
Home Cursor.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_home_cursor (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;
	unsigned long		  l_position_code;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "ii"
	    ,&l_display_id
	    ,&l_position_code
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	/* argument 2: position_code */

	/* -------------------- */
	l_status = smg$home_cursor
		(&l_display_id
		,&l_position_code
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_home_cursor () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_HOME_CURSOR.C */
