/* VMS_SMG_NAME_TO_KEYCODE.C -- 22-MAR-2000 Uwe Zessin
   Python interface to SMG$NAME_TO_KEYCODE

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_NAME_TO_KEYCODE

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_NAME_TO_KEYCODE "20000322"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <descrip.h>
#include <smg$routines.h>	/* SMG$name */
#include <ssdef.h>		/* SS$_name */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_name_to_keycode__doc[] =
"key_code = vms_smg.name_to_keycode (key_name)\n\
Translate a Key Name into a Key Code.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_name_to_keycode (PyObject *self, PyObject *args)
{
	char			* at_key_name;
	struct dsc$descriptor_s   r_key_name;
	unsigned long		  l_key_name_len;

	unsigned short		  w_key_code;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "s#", &at_key_name, &l_key_name_len))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: key_name */
	if (l_key_name_len > 65535)
	{
	    PyErr_SetString(PyExc_ValueError,
	     "argument 1: key_name - string size limited to 65535 characters");
	    return NULL;
	}
	r_key_name.dsc$w_length  = l_key_name_len;
	r_key_name.dsc$b_dtype   = DSC$K_DTYPE_T;
	r_key_name.dsc$b_class   = DSC$K_CLASS_S;
	r_key_name.dsc$a_pointer = at_key_name;

	/* -------------------- */
	l_status = smg$name_to_keycode
		(&r_key_name
		,&w_key_code
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    return Py_BuildValue ("i", (unsigned int)w_key_code);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_name_to_keycode () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_NAME_TO_KEYCODE.C */
