/* VMS_SMG_PUT_HELP_TEXT.C -- 25-MAR-2000 Uwe Zessin
   Python interface to SMG$PUT_HELP_TEXT

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_PUT_HELP_TEXT

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_PUT_HELP_TEXT "20000325"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <descrip.h>
#include <smg$routines.h>	/* SMG$name */
#include <ssdef.h>		/* SS$_name */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_put_help_text__doc[] =
"None = vms_smg.put_help_text (display_id, [keyboard_id],\
 [help_topic], [help_library], [rendition_set], [rendition_complement])\n\
Output Help Text to the Display.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_put_help_text (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;

	PyObject		* ar_keyboard_id;
	unsigned long		  l_keyboard_id;
	unsigned long		* al_keyboard_id;

	char			* at_help_topic;
	struct dsc$descriptor_s   r_help_topic;
	struct dsc$descriptor_s * ar_help_topic;
	unsigned long		  l_help_topic_len;

	char			* at_help_library;
	struct dsc$descriptor_s   r_help_library;
	struct dsc$descriptor_s * ar_help_library;
	unsigned long		  l_help_library_len;

	PyObject		* ar_rendition_set;
	unsigned long		  l_rendition_set;
	unsigned long		* al_rendition_set;

	PyObject		* ar_rendition_complement;
	unsigned long		  l_rendition_complement;
	unsigned long		* al_rendition_complement;

	unsigned long		  l_status;

	/* -------------------- */
	ar_keyboard_id          = Py_None;
	at_help_topic           = NULL;    l_help_topic_len   = 0;
	at_help_library         = NULL;    l_help_library_len = 0;
	ar_rendition_set        = Py_None;
	ar_rendition_complement = Py_None;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i|Oz#z#OO"
	    ,&l_display_id
	    ,&ar_keyboard_id
	    ,&at_help_topic          ,&l_help_topic_len
	    ,&at_help_library        ,&l_help_library_len
	    ,&ar_rendition_set
	    ,&ar_rendition_complement
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	/* argument 2: [keyboard_id] */
	if (ar_keyboard_id == Py_None)
	{
	    al_keyboard_id = 0;		/* omitted */
	    l_keyboard_id  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_keyboard_id))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 2: keyboard_id - must be integer or None");
		return NULL;
	    }
	    l_keyboard_id = PyInt_AsLong(ar_keyboard_id);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_keyboard_id = &l_keyboard_id;
	}

	/* -------------------- */
	/* argument 3: help_topic */
	if (at_help_topic == NULL)
	{
	    ar_help_topic = 0;	/* omitted */
	}
	else
	{
	    if (l_help_topic_len > 65535)
	    {
		PyErr_SetString(PyExc_ValueError,
	   "argument 3: help_topic - string size limited to 65535 characters");
		return NULL;
	    }
	    r_help_topic.dsc$w_length  = l_help_topic_len;
	    r_help_topic.dsc$b_dtype   = DSC$K_DTYPE_T;
	    r_help_topic.dsc$b_class   = DSC$K_CLASS_S;
	    r_help_topic.dsc$a_pointer = at_help_topic;
	    ar_help_topic = &r_help_topic;
	}

	/* -------------------- */
	/* argument 4: help_library */
	if (at_help_library == NULL)
	{
	    ar_help_library = 0;	/* omitted */
	}
	else
	{
	    if (l_help_library_len > 65535)
	    {
		PyErr_SetString(PyExc_ValueError,
	 "argument 4: help_library - string size limited to 65535 characters");
		return NULL;
	    }
	    r_help_library.dsc$w_length  = l_help_library_len;
	    r_help_library.dsc$b_dtype   = DSC$K_DTYPE_T;
	    r_help_library.dsc$b_class   = DSC$K_CLASS_S;
	    r_help_library.dsc$a_pointer = at_help_library;
	    ar_help_library = &r_help_library;
	}

	/* -------------------- */
	/* argument 5: [rendition_set] */
	if (ar_rendition_set == Py_None)
	{
	    al_rendition_set = 0;		/* omitted */
	    l_rendition_set  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_rendition_set))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 5: rendition_set - must be integer or None");
		return NULL;
	    }
	    l_rendition_set = PyInt_AsLong(ar_rendition_set);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_rendition_set = &l_rendition_set;
	}

	/* -------------------- */
	/* argument 6: [rendition_complement] */
	if (ar_rendition_complement == Py_None)
	{
	    al_rendition_complement = 0;		/* omitted */
	    l_rendition_complement  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_rendition_complement))
	    {
		PyErr_SetString(PyExc_TypeError,
		 "argument 6: rendition_complement - must be integer or None");
		return NULL;
	    }
	    l_rendition_complement = PyInt_AsLong(ar_rendition_complement);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_rendition_complement = &l_rendition_complement;
	}

	/* -------------------- */
	l_status = smg$put_help_text
		(&l_display_id
		,al_keyboard_id
		,ar_help_topic
		,ar_help_library
		,al_rendition_set
		,al_rendition_complement
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL) /* @@ SMG$_WILUSERMS */
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_put_help_text () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_PUT_HELP_TEXT.C */
