/* VMS_SMG_SAVE_PHYSICAL_SCREEN.C -- 01-APR-2000 Uwe Zessin
   Python interface to SMG$SAVE_PHYSICAL_SCREEN

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_SAVE_PHYSICAL_SCREEN

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_SAVE_PHYSICAL_SCREEN "20000401"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name */
#include <ssdef.h>		/* SS$_name */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_save_physical_scrn__doc[] =
"display_id = vms_smg.save_physical_screen\
 (pasteboard_id, [desired_start_row], [desired_end_row])\n\
Save Physical Screen.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_save_physical_screen (PyObject *self, PyObject *args)
{
	unsigned long		  l_pasteboard_id;

	PyObject		* ar_desired_start_row;
	long			  l_desired_start_row;
	long			* al_desired_start_row;

	PyObject		* ar_desired_end_row;
	long			  l_desired_end_row;
	long			* al_desired_end_row;

	unsigned long		  l_display_id;

	unsigned long		  l_status;

	/* -------------------- */
	ar_desired_start_row = Py_None;
	ar_desired_end_row   = Py_None;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i|OO"
	    ,&l_pasteboard_id
	    ,&ar_desired_start_row
	    ,&ar_desired_end_row
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: pasteboard_id */

	/* -------------------- */
	/* argument 2: [desired_start_row] */
	if (ar_desired_start_row == Py_None)
	{
	    al_desired_start_row = 0;		/* omitted */
	    l_desired_start_row  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_desired_start_row))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 2: desired_start_row - must be integer or None");
		return NULL;
	    }
	    l_desired_start_row = PyInt_AsLong(ar_desired_start_row);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_desired_start_row = &l_desired_start_row;
	}

	/* -------------------- */
	/* argument 3: [desired_end_row] */
	if (ar_desired_end_row == Py_None)
	{
	    al_desired_end_row = 0;		/* omitted */
	    l_desired_end_row  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_desired_end_row))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 3: desired_end_row - must be integer or None");
		return NULL;
	    }
	    l_desired_end_row = PyInt_AsLong(ar_desired_end_row);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_desired_end_row = &l_desired_end_row;
	}

	/* -------------------- */
	l_status = smg$save_physical_screen
		(&l_pasteboard_id
		,&l_display_id
		,al_desired_start_row
		,al_desired_end_row
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    return Py_BuildValue ("i", l_display_id);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_save_physical_screen () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_SAVE_PHYSICAL_SCREEN.C */
