/* VMS_SMG_SET_PHYSICAL_CURSOR.C -- 01-APR-2000 Uwe Zessin
   Python interface to SMG$SET_PHYSICAL_CURSOR

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_SET_PHYSICAL_CURSOR

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_SET_PHYSICAL_CURSOR "20000401"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name */
#include <ssdef.h>		/* SS$_name */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_set_physical_curs__doc[] =
"None = vms_smg.set_physical_cursor\
 (pasteboard_id, pasteboard_row, pasteboard_column)\n\
Set Cursor on Physical Screen.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_set_physical_cursor (PyObject *self, PyObject *args)
{
	unsigned long		  l_pasteboard_id;
	long			  l_pasteboard_row;
	long			  l_pasteboard_column;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "iii"
	    ,&l_pasteboard_id
	    ,&l_pasteboard_row
	    ,&l_pasteboard_column
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: pasteboard_id */

	/* -------------------- */
	/* argument 2: pasteboard_row */

	/* -------------------- */
	/* argument 3: pasteboard_column */

	/* -------------------- */
	l_status = smg$set_physical_cursor
		(&l_pasteboard_id
		,&l_pasteboard_row
		,&l_pasteboard_column
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_set_physical_cursor () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_SET_PHYSICAL_CURSOR.C */
