/* VMS_SMG_SNAPSHOT_TO_PRINTER.C -- 02-APR-2000 Uwe Zessin
   Python interface to SMG$SNAPSHOT_TO_PRINTER

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_SNAPSHOT_TO_PRINTER

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_SNAPSHOT_TO_PRINTER "20000402"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <descrip.h>
#include <smg$routines.h>	/* SMG$name */
#include <ssdef.h>		/* SS$_name */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_snapshot_to_prt__doc[] =
"None = vms_smg.snapshot_to_printer (pasteboard_id, device_type, [flags])\n\
Write Snapshot to Printer.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_snapshot_to_printer (PyObject *self, PyObject *args)
{
	unsigned long		  l_pasteboard_id;

	char			* at_device_type;
	struct dsc$descriptor_s   r_device_type;
	unsigned long		  l_device_type_len;

	PyObject		* ar_flags;
	unsigned long		  l_flags;
	unsigned long		* al_flags;

	unsigned long		  l_status;

	/* -------------------- */
	ar_flags = Py_None;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "is#|O"
	    ,&l_pasteboard_id
	    ,&at_device_type  ,&l_device_type_len
	    ,&ar_flags
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: pasteboard_id */

	/* -------------------- */
	/* argument 2: [device_type} */
	if (l_device_type_len > 65535)
	{
	    PyErr_SetString(PyExc_ValueError,
	  "argument 2: device_type - string size limited to 65535 characters");
	    return NULL;
	}
	r_device_type.dsc$w_length  = l_device_type_len;
	r_device_type.dsc$b_dtype   = DSC$K_DTYPE_T;
	r_device_type.dsc$b_class   = DSC$K_CLASS_S;
	r_device_type.dsc$a_pointer = at_device_type;

	/* -------------------- */
	/* argument 3: [flags] */
	if (ar_flags == Py_None)
	{
	    al_flags = 0;		/* omitted */
	    l_flags  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_flags))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 3: flags - must be integer or None");
		return NULL;
	    }
	    l_flags = PyInt_AsLong(ar_flags);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_flags = &l_flags;
	}

	/* -------------------- */
	l_status = smg$snapshot_to_printer
		(&l_pasteboard_id
		,&r_device_type
		,al_flags
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_snapshot_to_printer () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_SNAPSHOT_TO_PRINTER.C */
