/* VMS_SMG_UNPASTE_VIRTUAL_DISPLAY.C -- 02-APR-2000 Uwe Zessin
   Python interface to SMG$UNPASTE_VIRTUAL_DISPLAY

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_UNPASTE_VIRTUAL_DISPLAY

03-JUL-2000 ZE. -- return status code, because when pasteboard is batched
		'%SMG-S-BATWAS_ON, batching was on' is returned, which did
		raise an exception, before.
*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_UNPASTE_VIRTUAL_DISPLAY "20000703"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name  */
#include <smgmsg.h>		/* SMG$_name */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_unpaste_virtual_dp__doc[] =
"status = vms_smg.unpaste_virtual_display (display_id, pasteboard_id)\n\
Remove Virtual Display.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_unpaste_virtual_display (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;
	unsigned long		  l_pasteboard_id;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "ii"
	    ,&l_display_id
	    ,&l_pasteboard_id
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	/* argument 2: pasteboard_id */

	/* -------------------- */
	l_status = smg$unpaste_virtual_display
		(&l_display_id
		,&l_pasteboard_id
		);

	/* -------------------- */
	if ((l_status == SS$_NORMAL) || (l_status == SMG$_BATWAS_ON))
	{
	    return Py_BuildValue ("i", l_status);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_unpaste_virtual_display () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_UNPASTE_VIRTUAL_DISPLAY.C */
