/* VMS_SYS_BINUTC.C -- 16-JAN-2000 Uwe Zessin
   Python interface to SYS$BINUTC()

12-DEC-1997 ZE. -- created in VMS_SYS.C
16-JAN-2000 ZE. -- extract into VMS_SYS_BINUTC.C for V5.5-2 exclusion
*/

#ifdef __DECC
#pragma module VMS_SYS_BINUTC "20000116"
#endif

#include "python.h"
#include "vmsdef.h"

#include <descrip.h>
#include <ssdef.h>		/* SS$_name	 */
#include <starlet.h>		/* SYS$name, ... */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_sys_gr_error;	/* in VMS_SYS.C */
/* ------------------------------------------------------------------------- */

/* input a binary octaword, output a Python long integer */
extern PyObject * vms__cvt_octa2pylong (long q_octaword[4]);

/* ------------------------------------------------------------------------- */

char vms_sys_binutc__doc[] =
"utcadr = vms_sys.binutc (timbuf)\n\
Convert ASCII String to UTC Binary Time.";

PyObject *
vms_sys_binutc (PyObject *self, PyObject *args)
{
	char			* at_timbuf;	/* ASCII time */
	struct dsc$descriptor_s   r_timbuf;
	unsigned long		  l_timbuf_len;

	long			  o_utcadr[4];	/* utc_date_time */

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "s#", &at_timbuf, &l_timbuf_len))
	{
	    return NULL;
	}

	/* -------------------- */
	if (l_timbuf_len > 65535)
	{
	    PyErr_SetString(PyExc_ValueError,
	       "argument 1: timbuf - string size limited to 65535 characters");
	    return NULL;
	}
	/* set up descriptor */
	r_timbuf.dsc$w_length  = l_timbuf_len;
	r_timbuf.dsc$b_dtype   = DSC$K_DTYPE_T;
	r_timbuf.dsc$b_class   = DSC$K_CLASS_S;
	r_timbuf.dsc$a_pointer = at_timbuf;

	/* -------------------- */
	l_status = sys$binutc
		(&r_timbuf		/* timbuf */
		,&o_utcadr		/* utcadr */
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    /* convert binary octaword to Python long integer */
	    return vms__cvt_octa2pylong (&o_utcadr[0]);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_sys_gr_error, 1, l_status);
} /* vms_sys_binutc () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SYS_BINUTC.C */
